<?php

class AlbumController extends RController
{
    /**
     * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
     * using two-column layout. See 'protected/views/layouts/column2.php'.
     */
    // public $layout='//layouts/column2';

    /**
     * @return array action filters
     */
    public function filters()
    {
        return array(
            'rights',
            'postOnly + delete', // we only allow deletion via POST request
        );
    }

    public function actions()
    {
        return array(
            'batchOperation' => array(
                'class' => 'admin.components.actions.BatchOperationAction',
            ),
        );
    }

    /**
     * Displays a particular model.
     * @param integer $id the ID of the model to be displayed
     */
    public function actionView($id)
    {
        $this->render('view', array(
            'model' => $this->loadModel($id),
        ));
    }

    /**
     * Creates a new model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     */
    public function actionCreate()
    {
        $model = new Album;

        // Uncomment the following line if AJAX validation is needed
        // $this->performAjaxValidation($model);

        if (isset($_POST['Album'])) {
            $model->attributes = $_POST['Album'];
            $model->image = CUploadedFile::getInstance($model, 'image');

            if ($model->image != NULL) {
                if ($model->validate(null, false)) {
                    $picname = uniqid() . '.' . $model->image->getExtensionName();
                    $saveDir = Yii::app()->params['uploadDir'] . get_class($model);
                    $path = $saveDir . '/' . $picname;
                    if ($model->image->saveAs($path)) {
                        $imageObj = Yii::app()->image->load($path);
                        $new_height = 96;
                        $new_width = round(($imageObj->width * $new_height) / $imageObj->height);
                        $imageObj->resize($new_width, $new_height, Image::NONE);
                        $imageObj->save($saveDir . '/thumbs/' . $picname);
                        $model->image = $picname;
                    }
                }
            }

            if ($model->save()) {
                $this->redirect(array('create'));
            }
        }

        $this->render('create', array(
            'model' => $model,
        ));
    }

    /**
     * Updates a particular model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id the ID of the model to be updated
     */
    public function actionUpdate($id)
    {
        $model = $this->loadModel($id);

        // Uncomment the following line if AJAX validation is needed
        // $this->performAjaxValidation($model);

        if (isset($_POST['Album'])) {
            $old_image = $model->image;
            $model->attributes = $_POST['Album'];
            $model->image = CUploadedFile::getInstance($model, 'image');

            if ($model->image != NULL) {
                if ($model->validate(null, false)) {
                    $name = uniqid() . '.' . $model->image->getExtensionName();
                    $path = Yii::app()->params['uploadDir'] . get_class($model) . '/' . $name;
                    if ($model->image->saveAs($path)) {
                        $model->image = $name;
                    }
                }
            } else {
                $model->image = $old_image;
            }

            if ($model->save()) {
                Yii::app()->user->setFlash('alert-success', Yii::t('admin', 'Item has been successfully updated.'));
                $this->redirect(array('admin'));
            }
        }

        $this->render('update', array(
            'model' => $model,
        ));
    }

    /**
     * Deletes a particular model.
     * If deletion is successful, the browser will be redirected to the 'admin' page.
     * @param integer $id the ID of the model to be deleted
     */
    public function actionDelete($id)
    {
        $model = $this->loadModel($id);
        $model->delete();

        $path = Yii::app()->params['uploadDir'] . get_class($model) . '/';
        @unlink($path . $model->image);

        if ($model->albumImages) {
            foreach ($model->albumImages as $image) {
                $path = $image = Yii::app()->params['uploadDir'] . get_class($image) . '/';
                @unlink($path . $model->image);
            }
        }


        // if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
        if (!isset($_GET['ajax'])) {
            Yii::app()->user->setFlash('alert-success', Yii::t('admin', 'Item has been successfully deleted.'));
            $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
        }
    }

    /**
     * Lists all models.
     */
    public function actionIndex()
    {
        $dataProvider = new CActiveDataProvider('Album');
        $this->render('index', array(
            'dataProvider' => $dataProvider,
        ));
    }

    /**
     * Manages all models.
     */
    public function actionAdmin()
    {
        $model = new Album('search');
        $model->unsetAttributes();  // clear any default values
        if (isset($_GET['Album']))
            $model->attributes = $_GET['Album'];

        $this->render('admin', array(
            'model' => $model,
        ));
    }

    /**
     * Returns the data model based on the primary key given in the GET variable.
     * If the data model is not found, an HTTP exception will be raised.
     * @param integer $id the ID of the model to be loaded
     * @return Album the loaded model
     * @throws CHttpException
     */
    public function loadModel($id)
    {
        $model = Album::model()->findByPk($id);
        if ($model === null)
            throw new CHttpException(404, 'The requested page does not exist.');
        return $model;
    }

    /**
     * Performs the AJAX validation.
     * @param Album $model the model to be validated
     */
    protected function performAjaxValidation($model)
    {
        if (isset($_POST['ajax']) && $_POST['ajax'] === 'album-form') {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }
}
